var dateTimeFormatOptions = { year: 'numeric', month: '2-digit', day: '2-digit', hour: '2-digit', minute: '2-digit' };
var dateFormatOptions = { year: 'numeric', month: '2-digit', day: '2-digit' };

function modifyLoginPage() {
    if (document.getElementById("Username") !== null)
        modifySignInPage();
    if (document.getElementById("InvitationCode") !== null)
        modifyJoinPage();
    if (document.getElementById("ContentContainer_MainContent_MainContent_SecureRegister") !== null)
        modifyRegisterPage();
    if (document.getElementById("Code") !== null)
        modifyTwoFactorPage();
}

function modifySignInPage() {

    var returnUrl = getParameterByName('returnUrl');
    if (returnUrl == null)
        returnUrl = "";

    var signinContent = `
    <form action='/SignIn?ReturnUrl=`+ encodeURIComponent(returnUrl) + `' method='post' id='signinForm'>
        <div class='row'>
            <div style='width: 350px;float: none;margin: 0 auto; padding-top: 100px'>
                <table style='width: 100%'>
                    <tr style='border: 0px;'>
                        <td style='width: 50%; border: 0px; border-bottom: 1px solid #808080;'>
                            <div style='text-align: center; width: 100%; padding-top: 10px; padding-bottom: 10px; border-bottom: 5px solid #808080; font-size: 20px; margin-bottom: -1px;'>Sign In</div>
                        </td>
                        <td style='width: 50%; border: 0px; border-bottom: 1px solid #808080;'>
                            <div style='text-align: center; width: 100%; padding-top: 10px; padding-bottom: 10px; font-size: 20px;'>
                                <a href='/register/?'>Join</a>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan='2'>
                            <div style='padding-top:30px; padding-bottom:20px; text-align:left; width: 100%; font-size: 16px'>Sign In to your existing Account.</div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan='2' id='validationDiv'></td>
                    </tr>

                    <tr>
                        <td colspan='2'>
                            <div class='form-floating' id="usernameDiv">
                                <label>Username</label>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan='2'>
                            <div class='form-floating' id="passwordDiv">
                                <label>Password</label>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan='2'>
                            <div style='padding-top:10px; padding-bottom:10px; text-align:center; width: 100%' id="signinDiv">
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan='2'>
                            <div style='padding-top:10px; padding-bottom:10px; text-align:center; width: 100%'>
                                <a role='button' href='/Account/Login/ForgotPassword' title='Forgot your password?' style='width: 100%'>Forgot your password?</a>
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
        </div>
    </form>`;

    var usernameInput = document.querySelector("#Username");
    if (usernameInput === null)
        return;

    var passwordInput = document.querySelector("#Password");
    if (passwordInput == null)
        passwordInput = document.querySelector("#PasswordValue");
    if (passwordInput == null)
        return;

    var signinButton = document.querySelector("#submit-signin-local");
    if (signinButton == null)
        return;

    var validationDiv = document.querySelector("#loginValidationSummary");
    if (validationDiv == null)
        return;

    var validationToken = document.getElementsByName("__RequestVerificationToken")[0];
    if (validationToken == null)
        return;

    //var loginSection = usernameInput.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement;
    //var loginSectionParent = loginSection.parentElement;

    //loginSection.style.display = 'none';

    //loginSectionParent.parentElement.children[0].style.display = 'none';


    var contentSection = document.getElementById("content");

    contentSection.style.display = 'none';

    var newPanel = document.createElement("div");
    newPanel.id = "newContent";
    newPanel.innerHTML = signinContent;
    //loginSectionParent.appendChild(newPanel);
    contentSection.parentElement.appendChild(newPanel);

    usernameInput.className = "floating-form-control";
    usernameInput.placeholder = ' ';
    document.getElementById("usernameDiv").prepend(usernameInput);


    passwordInput.className = "floating-form-control";
    passwordInput.placeholder = ' ';
    document.getElementById("passwordDiv").prepend(passwordInput);

    signinButton.className += " loginInput";
    document.getElementById("signinDiv").appendChild(signinButton);

    document.getElementById("validationDiv").appendChild(validationDiv);

    document.getElementById("signinForm").appendChild(validationToken);

    try {

        setTimeout(function () { document.getElementById('PasswordValue').focus(); }, 100);
    } catch (ex) { }

    try {

        setTimeout(function () { document.getElementById('Username').focus(); }, 150);
    } catch (ex) { }

}

function modifyJoinPage() {
    var joinContent = `
    <form action='/Register?returnUrl=%2F' method='post' id='joinForm'>
        <div class='row'>
            <div style='width: 350px;float: none;margin: 0 auto; padding-top: 100px'>
                <table style='width: 100%'>
                    <tr style='border: 0px;'>
                        <td style='width: 50%; border: 0px; border-bottom: 1px solid #808080;'>
                            <div style='text-align: center; width: 100%; padding-top: 10px; padding-bottom: 10px; font-size: 20px;'>
                                <a href='/signin/?'>Sign In</a>
                            </div>
                        </td>
                        <td style='width: 50%; border: 0px; border-bottom: 1px solid #808080;'>
                            <div style='text-align: center; width: 100%; padding-top: 10px; padding-bottom: 10px; border-bottom: 5px solid #808080; font-size: 20px; margin-bottom: -1px;'>Join</div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan='2'>
                            <div style='padding-top:30px; padding-bottom:20px; text-align:left; width: 100%; font-size: 16px'>\
                            If you are attempting to join the WCDAO Portal, please contact the Westchester County District Attorney's Office at <a href='mailto:ITMailbox@westchesterda.net'>ITMailbox@westchesterda.net</a> to request a registration form.</div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan='2' id='validationDiv'></td>
                    </tr>
                    <tr>
                        <td colspan='2'>
                            <div style='padding-top:20px; padding-bottom:5px; text-align:center; width: 100%' id="invitationDiv">
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan='2'>
                            <div style='padding-top:30px; padding-bottom:10px; text-align:center; width: 100%' id="submitDiv">
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
        </div>
    </form>`;

    debugger;

    var invitationCodeInput = document.getElementById("InvitationCode");
    if (invitationCodeInput === null)
        return;

    var joinSection = invitationCodeInput.parentElement.parentElement.parentElement.parentElement.parentElement;
    var joinSectionParent = joinSection.parentElement;

    joinSection.style.display = 'none';

    joinSectionParent.parentElement.children[0].style.display = 'none';
    var newPanel = document.createElement("div");
    newPanel.innerHTML = joinContent;
    joinSectionParent.parentElement.appendChild(newPanel);

    invitationCodeInput.className += " loginInput";
    invitationCodeInput.placeholder = 'Invitation Code';
    document.getElementById("invitationDiv").appendChild(invitationCodeInput);

    var joinButton = document.querySelector("#submit-redeem-invitation");
    joinButton.className += " loginInput";
    document.getElementById("submitDiv").appendChild(joinButton);

    var validationDiv = document.querySelector("#redeemInvitation-validation-summary");
    if (validationDiv.children != null && validationDiv.children.length > 0)
        validationDiv.children[0].className = 'alertStyle';
    document.getElementById("validationDiv").appendChild(validationDiv);

    var validationToken = document.getElementsByName("__RequestVerificationToken")[0];
    document.getElementById("joinForm").appendChild(validationToken);
}

function modifyRegisterPage() {
    var registerContent = `
        <div class='row'>
            <div style='width: 350px;float: none;margin: 0 auto; padding-top: 100px'>
                <table style='width: 100%'>
                    <tr style='border: 0px;'>
                        <td style='width: 50%; border: 0px; border-bottom: 1px solid #808080;'>
                            <div style='text-align: center; width: 100%; padding-top: 10px; padding-bottom: 10px; font-size: 20px;'>
                                <a href='/signin/?'>Sign In</a>
                            </div>
                        </td>
                        <td style='width: 50%; border: 0px; border-bottom: 1px solid #808080;'>
                            <div style='text-align: center; width: 100%; padding-top: 10px; padding-bottom: 10px; border-bottom: 5px solid #808080; font-size: 20px; margin-bottom: -1px;'>Join</div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan='2'>
                            <div style='padding:10px; margin-top:30px; marging-bottom: 10px; text-align:left; width: 100%; max-width: 350px; background-color: blanchedalmond;' id="messageDiv">
                            </div>
                        </td>
                    </tr> 
                    <tr>
                        <td colspan='2'>
                            <div style='padding-top:20px; padding-bottom:5px; text-align:center; width: 100%' id="alertDiv">
                            </div>
                        </td>
                    </tr> 
                    <tr>
                        <td colspan='2'>
                            <div style='padding-top:20px; padding-bottom:5px; text-align:center; width: 100%' id="usernameDiv">
                            </div>
                        </td>
                    </tr> 
                    <tr>
                        <td colspan='2'>
                            <div style='padding-top:20px; padding-bottom:5px; text-align:center; width: 100%' id="password1Div">
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan='2'>
                            <div style='padding-top:20px; padding-bottom:5px; text-align:center; width: 100%' id="password2Div">
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan='2'>
                            <div style='padding-top:30px; padding-bottom:10px; text-align:center; width: 100%' id="submitDiv">
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
        </div>`;

    var emailInput = document.getElementById("EmailTextBox");
    if (emailInput === null)
        emailInput = document.getElementById("ContentContainer_MainContent_MainContent_EmailTextBox");
    if (emailInput === null)
        return;

    var usernameInput = document.getElementById("UserNameTextBox");
    if (usernameInput === null)
        usernameInput = document.getElementById("ContentContainer_MainContent_MainContent_UserNameTextBox");
    if (usernameInput === null)
        return;

    var password1Input = document.getElementById("PasswordTextBox");
    if (password1Input === null)
        password1Input = document.getElementById("ContentContainer_MainContent_MainContent_PasswordTextBox");
    if (password1Input === null)
        return;

    var password2Input = document.getElementById("ConfirmPasswordTextBox");
    if (password2Input === null)
        password2Input = document.getElementById("ContentContainer_MainContent_MainContent_ConfirmPasswordTextBox");
    if (password2Input === null)
        return;

    var submitButton = document.getElementById("SubmitButton");
    if (submitButton === null)
        submitButton = document.getElementById("ContentContainer_MainContent_MainContent_SubmitButton");
    if (submitButton === null)
        return;

    var registerMainPanel = document.getElementById("ContentContainer_MainContent_MainContent_SecureRegister");
    if (registerMainPanel === null)
        registerMainPanel = document.getElementById("SecureRegister");
    if (registerMainPanel === null)
        return;


    registerMainPanel.style.display = 'none';
    var messagePanel = registerMainPanel.children[0];

    registerMainPanel.parentElement.parentElement.parentElement.children[0].style.display = 'none';

    var newPanel = document.createElement("div");
    newPanel.innerHTML = registerContent;
    registerMainPanel.parentElement.appendChild(newPanel);
    var redeemCode = messagePanel.children[0].innerText;
    document.getElementById("messageDiv").innerHTML = "Redeeming Invitation Code:<div style='font-weight:bold;overflow: hidden; text-overflow: ellipsis; white-space: nowrap;' title='" + redeemCode + "'>" + redeemCode + "</div>Please create and confirm a password to complete registration.";

    usernameInput.className += " loginInput";
    usernameInput.value = emailInput.value;
    usernameInput.readOnly = true;
    usernameInput.setAttribute("autocomplete", "off");
    emailInput.readOnly = true;
    emailInput.setAttribute("autocomplete", "off");
    document.getElementById("usernameDiv").appendChild(usernameInput);

    password1Input.className += " loginInput";
    password1Input.placeholder = 'Password';
    document.getElementById("password1Div").appendChild(password1Input);

    password2Input.className += " loginInput";
    password2Input.placeholder = 'Confirm Password';
    document.getElementById("password2Div").appendChild(password2Input);

    submitButton.className += " loginInput";
    document.getElementById("submitDiv").appendChild(submitButton);

    if (document.getElementById("ContentContainer_MainContent_MainContent_ValidationSummary1") !== null) {
        document.getElementById("alertDiv").appendChild(document.getElementById("ContentContainer_MainContent_MainContent_ValidationSummary1"));
        document.getElementById("ContentContainer_MainContent_MainContent_ValidationSummary1").children[0].className = 'alertStyle';
    }
    else if (document.getElementById("ValidationSummary1") !== null) {
        document.getElementById("alertDiv").appendChild(document.getElementById("ValidationSummary1"));
        document.getElementById("ValidationSummary1").children[0].className = 'alertStyle';
    }
    else
        document.getElementById("alertDiv").style.display = 'none';

}

function modifyTwoFactorPage() {
    var parentFieldset = document.getElementsByTagName('fieldset')[0];
    parentFieldset.className += ' codeFieldset';
    document.getElementById('submit-verify-code').className = 'btn btn-primary loginInput';
    document.getElementById('Code').className += ' loginInput';
}

function changeDate1(s) {
    try { return Date.parse(s); }
    catch (ex) { return ''; }
}

function changeDate2(d) {
    if (typeof d === 'string' && d.length === 10 && d[4] === '-' && d[7] === '-') {
        return d[5] + d[6] + "/" + d[8] + d[9] + "/" + d[0] + d[1] + d[2] + d[3];
    }
    else if (typeof d === 'Date') {
        return ("0" + d.getDate()).slice(-2) + "/" + ("0" + (d.getMonth() + 1)).slice(-2) + "/" + d.getFullYear();
    }
}

function showProgressPanel(message) {
    document.getElementById("ProgressPanel").style.visibility = "visible";
    document.getElementById("ProgressMessage").innerHTML = message;
    document.getElementById("ProgressMessage").focus();
}

function hideProgressPanel() {
    document.getElementById("ProgressPanel").style.visibility = "hidden";
}

function changeToText(comp) {
    if (comp.value.length === 0) {
        comp.type = 'text';
    }
}

function formatDateTime(date) {
    if (date.getTime() == 0)
        return '';
    return date.toLocaleDateString(undefined, dateTimeFormatOptions);
}

function formatDateOnly(date) {
    if (date === null || date === '' || date.getTime() === 0)
        return '';
    return date.toLocaleDateString(undefined, dateFormatOptions);
}

function getParameterByName(name) {
    var match = RegExp('[?&]' + name + '=([^&]*)').exec(window.location.href.replace('%3F', '?'));
    return match && decodeURIComponent(match[1].replace(/\+/g, ' '));
}

function recordUserActivity() {
    var req = new XMLHttpRequest();
    req.open("GET", storageServer + "/portal/RecordUserActivity.aspx?secToken=" + encodeURIComponent(secToken) +
        "&id=" + Microsoft.Dynamic365.Portal.User.contactId, true);
    req.onreadystatechange = function () {
        if (req.readyState === 4) {
            console.log("recordUserActivity: " + req.responseText);
        }
    };
    req.send();
}

Date.prototype.withoutTime = function () {
    var d = new Date(this);
    d.setHours(0, 0, 0, 0);
    return d;
}